unit FClientDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, UDPAdvertiser, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    UDPAdUser: TUDPAdUser;
    LVServers: TListView;
    BUStartScan: TButton;
    MELog: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    Timer: TTimer;
    procedure BUStartScanClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure UDPAdUserAdvertisementReceived(sender: TObject;
      const infoString, ipAddress, computerName: String);
    procedure UDPAdUserNewAdvertiserDetected(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BUStartScanClick(Sender: TObject);
begin
   UDPAdUser.Active:=True;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
   // this is just to materialize activity,
   // you can safely set Active to True when it already is :)
   BUStartScan.Enabled:=not UDPAdUser.Active;
   if UDPAdUser.Active then
      BUStartScan.Caption:='Scanning...'
   else BUStartScan.Caption:='Start Scan';
end;

procedure TForm1.UDPAdUserAdvertisementReceived(sender: TObject;
  const infoString, ipAddress, computerName: String);
begin
   // logs advertisements as they are received
   MELog.Lines.Insert(0, Format('%s (%s) : "%s"', [computerName, ipAddress, infoString]));
end;

procedure TForm1.UDPAdUserNewAdvertiserDetected(Sender: TObject);
var
   i : Integer;
   adv : TDetectedAdvertiser;
begin
   // clean and fill up the list of servers
   with LVServers.Items do begin
      BeginUpdate;
      Clear;
      for i:=0 to UDPAdUser.DetectedAdvertisers.Count-1 do with Add do begin
         adv:=UDPAdUser.DetectedAdvertisers[i];
         Caption:=adv.IPAddress;
         SubItems.Add(adv.ComputerName);
         SubItems.Add(adv.InfoString);
      end;
      EndUpdate;
   end;
end;

end.
